## lizardfs 3.12.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are disabled for this project. This is for your "
    "safety. To build the project, please create a build tree in "
    "a separate directory, for example:\n"
    "     mkdir ${CMAKE_SOURCE_DIR}/build\n"
    "     cd ${CMAKE_SOURCE_DIR}/build\n"
    "     cmake ..\n"
    "Before doing that you may need to clean up after this try by removing "
    "CMakeCache.txt file and CMakeFiles/ directory.\n"
    "If you REALLY need an in-source build, remove this check from "
    "${CMAKE_CURRENT_LIST_FILE} and try again."
  )
endif()

set(DEFAULT_USER  "mfs" CACHE STRING "Default user to run daemons as")
set(DEFAULT_GROUP "mfs" CACHE STRING "Default group to run daemons as")
set(LIZARDFS_BLOCKS_IN_CHUNK 1024 CACHE INT "Number of blocks in one chunk")
set(LIZARDFS_BLOCK_SIZE 65536 CACHE INT "Number of bytes in one block")
option(ENABLE_WERROR        "Enable treating compilation warnings as errors"          OFF)
option(ENABLE_LIGHTMFS      "Enable light version of LizardFS"                        OFF)
option(ENABLE_DEBIAN_PATHS  "Enable Debian-style install paths"                       OFF)
option(ENABLE_UTILS         "Enable building additional binaries used e.g. in tests"  OFF)
option(ENABLE_TESTS         "Enable building unit and functional tests"               OFF)
option(ENABLE_DOCS          "Enable building the documentation"                       ON)
option(ENABLE_EXIT_ON_USR1  "Enable handler for SIGUSR1 which calls exit()"           OFF)
option(THROW_INSTEAD_OF_ABORT   "Throw std::exception instead of calling abort"       OFF)
option(ENABLE_DEBUG_LOG     "Enable prefix based debug logs"                          OFF)
option(ENABLE_VERBOSE_ASCIIDOC  "Enable verbose output of asciidoc"                   OFF)
option(ENABLE_TCMALLOC      "Enable use of tcmalloc-minimal library"                  OFF)
option(ENABLE_POLONAISE     "Enable polonaise"                                        ON)
option(ENABLE_CLIENT_LIB    "Enable dynamic client library (liblizardfs-client)"      OFF)
option(ENABLE_OFFICIAL_BUILD "Make the build official"                                OFF)
option(SET_RC_BUILD_NUMBER   "Sets optional -rcN build suffix"                        OFF)
# end of LizardFS options
option(ENABLE_TRACES        "Enable traces"                                           OFF)
option(ENABLE_CRC           "Enable checksums"                                        ON)
option(ENABLE_REQUEST_LOG   "Enable logging request times"                            OFF)
option(USE_LEGACY_READ_MESSAGES "Enable sending old type of messages by mount"        OFF)
option(ENABLE_NFS_GANESHA   "Enable nfs-ganesha plugin"                               OFF)

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "DEFAULT_USER: ${DEFAULT_USER}")
message(STATUS "DEFAULT_GROUP: ${DEFAULT_GROUP}")
message(STATUS "LIZARDFS_BLOCKS_IN_CHUNK: ${LIZARDFS_BLOCKS_IN_CHUNK}")
message(STATUS "LIZARDFS_BLOCK_SIZE: ${LIZARDFS_BLOCK_SIZE}")
message(STATUS "ENABLE_WERROR: ${ENABLE_WERROR}")
message(STATUS "ENABLE_LIGHTMFS: ${ENABLE_LIGHTMFS}")
message(STATUS "ENABLE_DEBIAN_PATHS: ${ENABLE_DEBIAN_PATHS}")
message(STATUS "ENABLE_UTILS: ${ENABLE_UTILS}")
message(STATUS "ENABLE_TESTS: ${ENABLE_TESTS}")
message(STATUS "ENABLE_DOCS: ${ENABLE_DOCS}")
message(STATUS "ENABLE_EXIT_ON_USR1: ${ENABLE_EXIT_ON_USR1}")
message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
message(STATUS "ENABLE_DEBUG_LOG: ${ENABLE_DEBUG_LOG}")
message(STATUS "ENABLE_VERBOSE_ASCIIDOC: ${ENABLE_VERBOSE_ASCIIDOC}")
message(STATUS "ENABLE_TCMALLOC: ${ENABLE_TCMALLOC}")
message(STATUS "ENABLE_POLONAISE: ${ENABLE_POLONAISE}")
message(STATUS "ENABLE_CLIENT_LIB: ${ENABLE_CLIENT_LIB}")
message(STATUS "ENABLE_OFFICIAL_BUILD: ${ENABLE_OFFICIAL_BUILD}")
message(STATUS "SET_RC_BUILD_NUMBER: ${SET_RC_BUILD_NUMBER}")
# end of LizardFS options values
message(STATUS "ENABLE_TRACES: ${ENABLE_TRACES}")
message(STATUS "ENABLE_CRC: ${ENABLE_CRC}")
message(STATUS "ENABLE_REQUEST_LOG: ${ENABLE_REQUEST_LOG}")
message(STATUS "USE_LEGACY_READ_MESSAGES: ${USE_LEGACY_READ_MESSAGES}")
message(STATUS "ENABLE_NFS_GANESHA: ${ENABLE_NFS_GANESHA}")

execute_process(COMMAND "git" "rev-parse" "HEAD"
  OUTPUT_VARIABLE GIT_SHA1 RESULT_VARIABLE GIT_SHA1_RETURN_VALUE
  OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT ENABLE_OFFICIAL_BUILD AND GIT_SHA1_RETURN_VALUE EQUAL 0)
	set(PACKAGE_VERSION_SUFFIX "-devel-${GIT_SHA1}")
elseif(NOT ENABLE_OFFICIAL_BUILD)
	set(PACKAGE_VERSION_SUFFIX "-devel")
elseif(SET_RC_BUILD_NUMBER)
	set(PACKAGE_VERSION_SUFFIX "-rc${SET_RC_BUILD_NUMBER}")
else()
	set(PACKAGE_VERSION_SUFFIX "")
endif()

if(ENABLE_CLIENT_LIB)
	set(ENABLE_PIC_TARGETS ON)
endif()

project(lizardfs)
set(PACKAGE_VERSION_MAJOR 3)
set(PACKAGE_VERSION_MINOR 12)
set(PACKAGE_VERSION_MICRO 0)
set(PACKAGE_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_MICRO}${PACKAGE_VERSION_SUFFIX}")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

set(CXX_STD c++0x)
if(CMAKE_CXX_COMPILER_ID MATCHES ".*Clang.*")
  set(CXX_STD c++11)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
endif()
if(MINGW)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat=0")
endif()
string(REPLACE "-DNDEBUG" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pipe -std=${CXX_STD} -pthread -Wall -Wextra -fwrapv")
set(CMAKE_CXX_FLAGS_DEBUG "-O0 -g")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -DNDEBUG -g")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -ftree-vectorize -g -fno-omit-frame-pointer")
set(CMAKE_CXX_FLAGS_COVERAGE "-O0 -g --coverage")
set(CMAKE_CXX_FLAGS_CLANG_ANALYZE "--analyze -Xanalyzer -analyzer-output=text")
set(CMAKE_CXX_FLAGS_CLANG_SANITIZE_THREAD "-g -O0 -fsanitize=thread")
set(CMAKE_CXX_FLAGS_CXXDEBUG "-O0 -g -D_GLIBCXX_DEBUG")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11 -Wall")

add_definitions(-D_LARGEFILE_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-DLIZARDFS_HAVE_CONFIG_H)
add_definitions(-D__STDC_LIMIT_MACROS)
add_definitions(-D__STDC_CONSTANT_MACROS)
add_definitions(-D__STDC_FORMAT_MACROS)
if(MINGW)
  add_definitions(-DWINVER=0x0602)
  add_definitions(-D_WIN32_WINNT=0x0602)
  add_definitions(-DFD_SETSIZE=1024)
endif()

# All the environment tests (libs, includes, etc.) live here:
include(EnvTests)
include(Libraries)
include(GNUInstallDirs)
include(CollectSources)
include(CreateUnitTest)

# Disable -pedantic for old gcc because of unfounded
# "no comma at end of enumerator list" warning during crcutil compilation
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE COMPILER_VERSION)
if(ENABLE_WERROR AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND COMPILER_VERSION VERSION_LESS 4.7)
  message(STATUS "Flag '-pedantic' disabled for GCC < 4.7")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
endif()

if(CXX_HAS_WNOGNU)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu")
endif()

if(ENABLE_WERROR)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

if(ENABLE_TESTS AND NOT THROW_INSTEAD_OF_ABORT)
  message(STATUS "Tests require THROW_INSTEAD_OF_ABORT to be set to YES, changing passed value:")
  set(THROW_INSTEAD_OF_ABORT YES)
  message(STATUS "THROW_INSTEAD_OF_ABORT: ${THROW_INSTEAD_OF_ABORT}")
endif()

get_property(LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (LIB64)
  set(LIBSUFFIX "64")
else()
  set(LIBSUFFIX "")
endif()
message(STATUS "LIB64: ${LIB64}")

if(ENABLE_DEBIAN_PATHS)
  if (NOT CMAKE_INSTALL_PREFIX STREQUAL "/")
    message(WARNING "Debian paths enabled, but CMAKE_INSTALL_PREFIX is different than /")
  endif()
  set(BIN_SUBDIR   "usr/bin")
  set(SBIN_SUBDIR  "usr/sbin")
  set(LIB_SUBDIR   "usr/lib${LIBSUFFIX}")
  set(ETC_SUBDIR   "etc/mfs")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "usr/share/man")
  set(CGI_SUBDIR   "usr/share/mfscgi")
  set(INCL_SUBDIR  "usr/include/lizardfs")
else()
  set(BIN_SUBDIR   "bin")
  set(SBIN_SUBDIR  "sbin")
  set(LIB_SUBDIR   "lib${LIBSUFFIX}")
  set(ETC_SUBDIR   "etc/mfs")
  set(RUN_SUBDIR   "var/run/mfs")
  set(DATA_SUBDIR  "var/lib/mfs")
  set(MAN_SUBDIR   "share/man")
  set(CGI_SUBDIR   "share/mfscgi")
  set(INCL_SUBDIR  "include/lizardfs")
endif()

string(REGEX REPLACE "/$" "" INSTALL_PREFIX_NO_SLASH ${CMAKE_INSTALL_PREFIX})
set(BIN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${BIN_SUBDIR})
set(SBIN_PATH  ${INSTALL_PREFIX_NO_SLASH}/${SBIN_SUBDIR})
set(LIB_PATH   ${INSTALL_PREFIX_NO_SLASH}/${LIB_SUBDIR})
set(ETC_PATH   ${INSTALL_PREFIX_NO_SLASH}/${ETC_SUBDIR})
set(RUN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${RUN_SUBDIR})
set(DATA_PATH  ${INSTALL_PREFIX_NO_SLASH}/${DATA_SUBDIR})
set(MAN_PATH   ${INSTALL_PREFIX_NO_SLASH}/${MAN_SUBDIR})
set(CGI_PATH   ${INSTALL_PREFIX_NO_SLASH}/${CGI_SUBDIR})
set(INCL_PATH  ${INSTALL_PREFIX_NO_SLASH}/${INCL_SUBDIR})

if(ENABLE_LIGHTMFS)
  set(PROTO_BASE 65536)
  set(LIGHT_MFS 1)
else()
  set(PROTO_BASE 0)
  set(LIGHT_MFS 0)
endif()

if(ENABLE_UTILS)
  set(BUILD_UTILS ON)
endif()

if(ENABLE_TESTS)
  set(BUILD_TESTS ON)
  set(BUILD_UTILS ON)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(ENABLE_DEBUG_LOG)
  set(LIZARDFS_ENABLE_DEBUG_LOG ON)
endif()

if(NOT Boost_INCLUDE_DIRS)
  message(FATAL_ERROR "Boost headers are required")
endif()

if(ENABLE_TRACES)
  add_definitions(-DENABLE_TRACES)
endif()

if(ENABLE_REQUEST_LOG)
  if(NOT Boost_IOSTREAMS_FOUND)
    message(FATAL_ERROR "Boost iostreams is required if request time logging is enabled")
  endif()
  set(ADDITIONAL_LIBS ${Boost_IOSTREAMS_LIBRARY})
  add_definitions(-DENABLE_REQUEST_LOG)
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

if(THROW_INSTEAD_OF_ABORT)
  add_definitions(-DTHROW_INSTEAD_OF_ABORT)
endif()

if(USE_LEGACY_READ_MESSAGES)
  add_definitions(-DUSE_LEGACY_READ_MESSAGES)
endif()

if(ENABLE_CRC)
  message(STATUS "CRC checksums enabled")
  add_definitions(-DENABLE_CRC)
else()
  message(STATUS "CRC checksums disabled")
endif()

set(CHARTS_CSV_CHARTID_BASE 90000)

# Create config.h file
configure_file(config.h.in config.h)
include_directories(${CMAKE_BINARY_DIR}) # Here we have generated config.h

# main.cc shared by some LizardFS applications
set(MAIN_SRC ${CMAKE_SOURCE_DIR}/src/main/main.cc)

if(ZLIB_FOUND)
  include_directories(${ZLIB_INCLUDE_DIRS})
endif()
include_directories(src) # Allow paths relative to src, eg. #include common/crc.h
include_directories(external/spdlog-0.14.0/include)
link_directories( ${LINK_DIRECTORIES} ${FUSE_LIBRARY_DIR} )
add_subdirectory(external)
add_subdirectory(src/admin)
add_subdirectory(src/common)
add_subdirectory(src/protocol)
add_subdirectory(src/mount)

if(ENABLE_POLONAISE)
  add_subdirectory(src/mount/polonaise)
endif()

if(NOT MINGW)
  if(BUILD_DEVTOOLS)
    add_subdirectory(src/devtools)
  endif()
  add_subdirectory(src/chunkserver)
  add_subdirectory(src/master)
  add_subdirectory(src/metadump)
  add_subdirectory(src/metalogger)
  add_subdirectory(src/metarestore)
  add_subdirectory(src/tools)
  if (FUSE_LIBRARY)
    add_subdirectory(src/mount/fuse)
  endif()
  add_subdirectory(src/data)
  add_subdirectory(src/cgi)
  if(BUILD_UTILS)
    add_subdirectory(utils)
  endif()
  if(ENABLE_DOCS)
    add_subdirectory(doc)
  endif()
  if(ENABLE_NFS_GANESHA)
    add_subdirectory(src/nfs-ganesha)
  endif()
endif()

if(BUILD_TESTS)
  add_subdirectory(src/unittests)
  add_subdirectory(tests)
endif()

=== doc/CMakeLists.txt ===
if(NOT A2X_BINARY)
  message(WARNING "Program 'a2x' not found, manpages won't be generated")
  return()
endif()

# These manpages should be generated
set(MANPAGES
    lizardfs.7          # not a source
    lizardfs-admin.8
    lizardfs-cgiserver.8
    lizardfs-probe.8    # not a source
    lizardfs-appendchunks.1
    lizardfs-checkfile.1
    lizardfs-dirinfo.1
    lizardfs-fileinfo.1
    lizardfs-filerepair.1
    lizardfs-geteattr.1
    lizardfs-seteattr.1       # not a source
    lizardfs-deleattr.1       # not a source
    lizardfs-getgoal.1
    lizardfs-setgoal.1        # not a source
    lizardfs-rgetgoal.1       # not a source
    lizardfs-rsetgoal.1       # not a source
    lizardfs-gettrashtime.1
    lizardfs-settrashtime.1   # not a source
    lizardfs-rgettrashtime.1  # not a source
    lizardfs-rsettrashtime.1  # not a source
    lizardfs-makesnapshot.1
    lizardfs-rremove.1
    mfsmount.1
    lizardfs-repquota.1
    lizardfs-setquota.1       # not a source
    lizardfs.1
    globaliolimits.cfg.5
    iolimits.cfg.5
    mfschunkserver.cfg.5
    mfsexports.cfg.5
    mfsgoals.cfg.5
    mfshdd.cfg.5
    mfsmaster.cfg.5
    mfsmetalogger.cfg.5
    mfsmount.cfg.5
    mfstopology.cfg.5
    mfsmetadump.8
    mfsrestoremaster.8
    moosefs.7
    mfs.7               # not a source
    mfscgiserv.8
    mfschunkserver.8
    mfsmaster.8
    mfsmetalogger.8
    mfsmetarestore.8
)

set(INSTALLED_MANPAGES)
foreach(MANPAGE ${MANPAGES})
  get_filename_component(MANPAGE_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${MANPAGE}.txt ABSOLUTE)
  string(REGEX MATCH "[0-9]$" SECTION_NUMBER ${MANPAGE})
  set(GENERATED_MANPAGE_PATH ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE})
  if(ENABLE_VERBOSE_ASCIIDOC)
    set(ASCIIDOC_VERBOSE --verbose --keep-artifacts)
  else()
    set(ASCIIDOC_VERBOSE)
  endif()
  if(EXISTS ${MANPAGE_SRC})
    # Generate from the source...
    set(MANPAGE_SRC_SYMLINK ${CMAKE_CURRENT_BINARY_DIR}/${MANPAGE}.txt)
    add_custom_command(OUTPUT ${GENERATED_MANPAGE_PATH}
        COMMAND ln -s -f ${MANPAGE_SRC} ${MANPAGE_SRC_SYMLINK}
        COMMAND a2x ${ASCIIDOC_VERBOSE} -L -f manpage ${MANPAGE_SRC_SYMLINK}
        DEPENDS ${MANPAGE_SRC})
    # Add this file to the main target's dependencies
    set(GENERATED_MANPAGES ${GENERATED_MANPAGES} ${GENERATED_MANPAGE_PATH})
  endif()
  # Install the generated file
  install(FILES ${GENERATED_MANPAGE_PATH} DESTINATION ${MAN_SUBDIR}/man${SECTION_NUMBER})
endforeach()
add_custom_target(manpages ALL SOURCES ${GENERATED_MANPAGES})

=== external/CMakeLists.txt ===
# crcutil

if(NOT CRCUTIL_FOUND)
  if(HAVE_CRCUTIL)
    include_directories(${CRCUTIL_INCLUDE_DIRS})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")
    file(GLOB CRCUTIL_SOURCES ${CRCUTIL_SOURCE_DIR}/*.cc)
    shared_add_library(crcutil ${CRCUTIL_SOURCES})
  endif()
endif()

# GoogleTest
if(BUILD_TESTS)
  if(ENABLE_WERROR)
    set(LIZARDFS_BACKUP_CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-missing-field-initializers")
  endif()
  include_directories(${GTEST_INCLUDE_DIRS})
  add_subdirectory(${GTEST_DIR_NAME})
  if(ENABLE_WERROR)
    set(CMAKE_CXX_FLAGS "${LIZARDFS_BACKUP_CMAKE_CXX_FLAGS}")
    unset(LIZARDFS_BACKUP_CMAKE_CXX_FLAGS)
  endif()
endif()

=== utils/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR})

install(PROGRAMS cpp-interpreter.sh DESTINATION ${BIN_SUBDIR})

# a library which causes pread/pwrite/close on chunks to return EIO
add_library(chunk_operations_eio SHARED chunk_operations_eio.c)
if(NOT CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  target_link_libraries(chunk_operations_eio dl)
endif()
install(TARGETS chunk_operations_eio DESTINATION ${LIB_SUBDIR})

# converter to xor chunks
add_executable(chunk_converter chunk_converter.cc)
target_link_libraries(chunk_converter ${ZLIB_LIBRARY})
install(TARGETS chunk_converter RUNTIME DESTINATION ${BIN_SUBDIR})

# crc converter
add_executable(crc_converter crc_converter.cc)
target_link_libraries(crc_converter ${ZLIB_LIBRARY})
install(TARGETS crc_converter RUNTIME DESTINATION ${BIN_SUBDIR})

# redirecting bind library
add_library(redirect_bind SHARED redirect_bind.c)
if(NOT CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  target_link_libraries(redirect_bind dl)
endif()
install(TARGETS redirect_bind DESTINATION ${LIB_SUBDIR})

# test files generator
add_executable(file-generate file_generate.cc)
install(TARGETS file-generate RUNTIME DESTINATION ${BIN_SUBDIR})

# test files generator which overwrites existing files
add_executable(file-overwrite file_overwrite.cc)
install(TARGETS file-overwrite RUNTIME DESTINATION ${BIN_SUBDIR})

# test files validator
add_executable(file-validate file_validate.cc)
install(TARGETS file-validate RUNTIME DESTINATION ${BIN_SUBDIR})

# utility for flock() system call
add_executable(flockcmd flockcmd.cc)
install(TARGETS flockcmd RUNTIME DESTINATION ${BIN_SUBDIR})

# utility for posix locks
add_executable(posixlockcmd posixlockcmd.cc)
install(TARGETS posixlockcmd RUNTIME DESTINATION ${BIN_SUBDIR})

# ping client
add_executable(mfsping mfs_ping.cc)
target_link_libraries(mfsping mfscommon)
install(TARGETS mfsping RUNTIME DESTINATION ${BIN_SUBDIR})

# ping server
add_executable(mfspingserv mfs_pingserv.cc)
target_link_libraries(mfspingserv mfscommon)
install(TARGETS mfspingserv RUNTIME DESTINATION ${BIN_SUBDIR})

# ping pong fcntl lock test
add_executable(lzfs_ping_pong ping_pong.cc)
install(TARGETS lzfs_ping_pong RUNTIME DESTINATION ${BIN_SUBDIR})

add_library(slow_chunk_scan SHARED slow_chunk_scan.c)
if(NOT CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  target_link_libraries(slow_chunk_scan dl)
endif()
install(TARGETS slow_chunk_scan DESTINATION ${LIB_SUBDIR})

=== src/admin/CMakeLists.txt ===
collect_sources(LIZARDFS_ADMIN)

add_library(lizardfs-admin-lib ${LIZARDFS_ADMIN_SOURCES})
target_link_libraries(lizardfs-admin-lib mfscommon)
create_unittest(lizardfs-admin-lib ${LIZARDFS_ADMIN_TESTS})
link_unittest(lizardfs-admin-lib mfscommon)

add_executable(lizardfs-admin ${LIZARDFS_ADMIN_MAIN})
target_link_libraries(lizardfs-admin lizardfs-admin-lib)
install(TARGETS lizardfs-admin RUNTIME DESTINATION ${BIN_SUBDIR})

add_custom_target(lizardfs-probe ALL
    COMMAND ln -sf lizardfs-admin lizardfs-probe
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS lizardfs-admin)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lizardfs-probe DESTINATION ${BIN_SUBDIR})

=== src/cgi/CMakeLists.txt ===
configure_file(cgiserv.py.in   mfscgiserv)
configure_file(lizardfs-cgiserver.py.in   lizardfs-cgiserver)
configure_file(chart.cgi.in    chart.cgi)
configure_file(mfs.cgi.in      mfs.cgi)

set(CGI_FILES err.gif favicon.ico index.html logomini.png mfs.css)
set(CGI_SCRIPTS
    ${CMAKE_CURRENT_BINARY_DIR}/mfs.cgi
    ${CMAKE_CURRENT_BINARY_DIR}/chart.cgi)
set(CGI_SERVERS
    ${CMAKE_CURRENT_BINARY_DIR}/mfscgiserv
    ${CMAKE_CURRENT_BINARY_DIR}/lizardfs-cgiserver)

install(FILES ${CGI_FILES} DESTINATION ${CGI_SUBDIR})
install(PROGRAMS ${CGI_SCRIPTS} DESTINATION ${CGI_SUBDIR})
install(PROGRAMS ${CGI_SERVERS} DESTINATION ${SBIN_SUBDIR})

=== src/chunkserver/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DLIZARDFS_MAX_FILES=10000)
add_definitions(-DAPPNAME=mfschunkserver)

collect_sources(CHUNKSERVER)
add_library(chunkserver ${CHUNKSERVER_SOURCES})
target_link_libraries(chunkserver lzfsprotocol mfscommon ${ADDITIONAL_LIBS})
create_unittest(chunkserver ${CHUNKSERVER_TESTS})
link_unittest(chunkserver chunkserver mfscommon)

add_executable(mfschunkserver ${MAIN_SRC})
target_link_libraries(mfschunkserver chunkserver ${PAM_LIBRARIES})

if(SYSTEMD_FOUND)
  target_link_libraries(mfschunkserver ${SYSTEMD_LIBRARIES})
endif()

install(TARGETS mfschunkserver RUNTIME DESTINATION ${SBIN_SUBDIR})

=== src/common/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

collect_sources(COMMON)

if(MINGW)
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/lockfile.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/metadata.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/setup.cc")
list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/loop_watchdog.cc")
endif()

if(ISAL_LIBRARY)
  list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/galois_field_isal.cc")
  list(REMOVE_ITEM COMMON_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/galois_field_encode.cc")
endif()


shared_add_library(mfscommon ${COMMON_SOURCES})
if (HAVE_CRCUTIL)
  # Use crcutil Library
  include_directories(${CRCUTIL_INCLUDE_DIRS})
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CRCUTIL_CXX_FLAGS}")
  shared_target_link_libraries(mfscommon ${CRCUTIL_LIBRARIES})
endif()
if (ZLIB_FOUND)
  shared_target_link_libraries(mfscommon ${ZLIB_LIBRARIES})
endif()
if (RT_LIBRARY)
  shared_target_link_libraries(mfscommon ${RT_LIBRARY})
endif()
if(TCMALLOC_LIBRARY)
  shared_target_link_libraries(mfscommon ${TCMALLOC_LIBRARY})
endif()
if(SOCKET_FOUND)
  shared_target_link_libraries(mfscommon ${SOCKET_LIBRARIES})
endif()
if(ISAL_LIBRARY)
  shared_target_link_libraries(mfscommon STATIC ${ISAL_LIBRARY} SHARED ${ISAL_PIC_LIBRARY})
endif()
if(JUDY_LIBRARY)
  shared_target_link_libraries(mfscommon ${JUDY_LIBRARY})
endif()

create_unittest(mfscommon ${COMMON_TESTS} ../master/goal_config_loader.cc)
link_unittest(mfscommon mfscommon)

=== src/data/CMakeLists.txt ===
configure_file(mfsmaster.cfg.in mfsmaster.cfg)
configure_file(mfschunkserver.cfg.in mfschunkserver.cfg)
configure_file(mfsmetalogger.cfg.in mfsmetalogger.cfg)
configure_file(postinst.in postinst)
set(POSTINST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/postinst PARENT_SCOPE)
install(FILES metadata.mfs DESTINATION ${DATA_SUBDIR} RENAME metadata.mfs.empty)
install(FILES mfsexports.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsexports.cfg.dist)
install(FILES mfsgoals.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsgoals.cfg.dist)
install(FILES mfshdd.cfg DESTINATION ${ETC_SUBDIR} RENAME mfshdd.cfg.dist)
install(FILES mfsmount.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsmount.cfg.dist)
install(FILES mfstopology.cfg DESTINATION ${ETC_SUBDIR} RENAME mfstopology.cfg.dist)
install(FILES globaliolimits.cfg DESTINATION ${ETC_SUBDIR} RENAME globaliolimits.cfg.dist)
install(FILES iolimits.cfg DESTINATION ${ETC_SUBDIR} RENAME iolimits.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfsmaster.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsmaster.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfschunkserver.cfg DESTINATION ${ETC_SUBDIR} RENAME mfschunkserver.cfg.dist)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mfsmetalogger.cfg DESTINATION ${ETC_SUBDIR} RENAME mfsmetalogger.cfg.dist)

install(FILES lizardfs.completion DESTINATION etc/bash_completion.d RENAME lizardfs)

=== src/devtools/CMakeLists.txt ===
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} DEVTOOLS_SOURCES)
add_library(devtools ${DEVTOOLS_SOURCES})

add_subdirectory(mycrc32)

=== src/master/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DAPPNAME=mfsmaster)

collect_sources(MASTER)

if(NOT DB_FOUND)
  list(REMOVE_ITEM MASTER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/hstring_bdbstorage.cc")
endif()

add_library(master ${MASTER_SOURCES})
target_link_libraries(master mfscommon ${ADDITIONAL_LIBS})
if(JUDY_LIBRARY)
  target_link_libraries(master ${JUDY_LIBRARY})
endif()
if(DB_FOUND)
  target_link_libraries(master ${DB_LIBRARY})
endif()
create_unittest(master ${MASTER_TESTS})
link_unittest(master master mfscommon)

add_executable(mfsmaster ${MAIN_SRC})
target_link_libraries(mfsmaster master ${PAM_LIBRARIES})
if(SYSTEMD_FOUND)
  target_link_libraries(mfsmaster ${SYSTEMD_LIBRARIES})
endif()
install(TARGETS mfsmaster RUNTIME DESTINATION ${SBIN_SUBDIR})

configure_file(mfsrestoremaster.in mfsrestoremaster @ONLY)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/mfsrestoremaster DESTINATION ${SBIN_SUBDIR})

=== src/metadump/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

aux_source_directory(. METADUMP_SOURCES)
add_executable(mfsmetadump ${METADUMP_SOURCES})
target_link_libraries(mfsmetadump)
install(TARGETS mfsmetadump RUNTIME DESTINATION ${SBIN_SUBDIR})

=== debian/changelog ===
lizardfs (3.12.0+dfsg-4ubuntu1) focal; urgency=medium

  * lizardfs-cgi: Depend on python2 instead of python.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 20 Jan 2020 00:00:32 +0100

lizardfs (3.12.0+dfsg-4) unstable; urgency=medium

  * mfs->lfs: re-named all executables to allow co-existence with MooseFS.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 19 Jan 2020 15:50:28 +1100

lizardfs (3.12.0+dfsg-3) unstable; urgency=medium

  * New patch to fix FTBFS with glibc-2.28 (Closes: #916194).

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 14 Dec 2018 14:06:58 +1100

lizardfs (3.12.0+dfsg-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Remove ancient X-Python-Version field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Dmitry Smirnov ]
  * New patch to fix FTBFS with spdlog >= 1.1.0 (Closes: #909764).
  * Build-Depends:
    = libspdlog-dev (>= 1:1.2.0~)
  * Standards-Version: 4.2.1.
  * rules: removed explicit "--parallel".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 03 Nov 2018 21:20:16 +1100

lizardfs (3.12.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Build-Depends += "libspdlog-dev".
  * Compile without "ENABLE_TESTS=YES".
  * Standards-Version: 4.1.3.
  * debhelper & compat to version 11.
  * rules: removed calls to "dpkg-parsechangelog".
  * watch: ignore "-rc" versions.
  * chunkserver.service:
    + Added "KeyringMode=inherit" to preserve e4crypt session keys.
    + Wants += "local-fs.target" to avoid starting service before
      (some) local mounts.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 12 Feb 2018 09:03:40 +1100

=== debian/control ===
Source: lizardfs
Section: admin
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper (>= 11~), dh-python, bash-completion ,dh-exec
              ,python-all
              ,cmake
              ,asciidoc
                  ,libxml2-utils
                  ,docbook-xml
                  ,docbook-xsl
                  ,xsltproc
              ,pkg-config
# libcrcutil is for little-endian architectures only.
              ,libcrcutil-dev [!hppa !m68k !mips !powerpc !powerpcspe !ppc64 !s390 !s390x !sparc !sparc64]
              ,libfuse-dev (>= 2.9.0)
              ,libdb-dev
#_beware:     ,libgoogle-perftools-dev
              ,googletest
              ,libisal-dev [amd64 kfreebsd-amd64]
              ,libjudy-dev
              ,libpam-dev
              ,libspdlog-dev (>= 1:1.2.0~)
              ,libsystemd-dev [!kfreebsd-any]
#             ,libthrift-dev
              ,zlib1g-dev
# -DENABLE_TESTS=YES requirements:
             ,libboost-all-dev
Standards-Version: 4.2.1
Homepage: http://lizardfs.org/
Vcs-Browser: https://salsa.debian.org/debian/lizardfs
Vcs-Git: https://salsa.debian.org/debian/lizardfs.git

Package: lizardfs-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
        ,adduser
Description: LizardFS - common files
 Files and services common for all LizardFS daemons.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-master
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - master server
 LizardFS master (metadata) server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-metalogger
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - metalogger server
 LizardFS metadata replication (backup) server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-chunkserver
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
        ,lizardfs-common (>= ${source:Version})
Description: LizardFS - data server
 The LizardFS data server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-client
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fuse
Description: LizardFS - client tools and mount utility
 LizardFS FUSE mount utility "mfsmount" and client tool "mfstools".
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-adm
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LizardFS - administration tools
 LizardFS administration tool: lizardfs-probe
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgi
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
        ,python2
Description: LizardFS - CGI monitor
 CGI application to monitor LizardFS through master/metadata server.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

Package: lizardfs-cgiserv
Built-Using: ${my:Built-Using}
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
        ,lizardfs-cgi
        ,lizardfs-common (>= ${source:Version})
        ,${python:Depends}
Description: simple CGI-capable HTTP server to run LizardFS CGI monitor
 Simple standalone CGI-capable HTTP server to run LizardFS CGI Monitor.
 .
 LizardFS is a reliable, scalable and efficient distributed file system. It
 spreads data over a number of physical servers, making it visible to an
 end user as a single file system.
 .
 Functions such as data replication, checksums, instant snapshots and easy
 connection of additional servers make LizardFS a perfect solution for
 users who need fault-proof storage ready for future expansion.
 LizardFS features include:
  * High availbility.
  * Quotas.
  * POSIX Access Control Lists and POSIX Extended Attributes.
  * I/O bandwidth limiting.
 .
 LizardFS can be used whenever one needs to store large quantities of data
 in a secure way and process them swiftly.
 LizardFS is a fork of MooseFS.

#Package: lizardfs-tests
#Built-Using: ${my:Built-Using}
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#        ,lizardfs-common (>= ${source:Version})
#        ,lizardfs-chunkserver (>= ${source:Version})
#        ,lizardfs-master (>= ${source:Version})
#        ,lizardfs-client (>= ${source:Version})
#        ,lizardfs-adm (>= ${source:Version})
#        ,attr
#        ,dbench
#        ,fuse
#        ,netcat-openbsd
#        ,socat
#        ,sudo
#        ,valgrind
#Description: LizardFS - tests suite
# The LizardFS test suite.
# .
# LizardFS is a reliable, scalable and efficient distributed file system. It
# spreads data over a number of physical servers, making it visible to an
# end user as a single file system.
# .
# Functions such as data replication, checksums, instant snapshots and easy
# connection of additional servers make LizardFS a perfect solution for
# users who need fault-proof storage ready for future expansion.
# LizardFS features include:
#  * High availbility.
#  * Quotas.
#  * POSIX Access Control Lists and POSIX Extended Attributes.
#  * I/O bandwidth limiting.
# .
# LizardFS can be used whenever one needs to store large quantities of data
# in a secure way and process them swiftly.
# LizardFS is a fork of MooseFS.

=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\-(\d+|rc)\Z}{~$1},\
 https://github.com/lizardfs/lizardfs/releases \
 .*/archive/v?\.?(\d[\d\.]+)\.tar\.gz
